local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local c = BittensSpellFlashLibrary2

local UncontrolledMitigationBuffs = {
    109774, -- Master Tactician LFR
    107986, -- Master Tactician
    109776, -- Master Tactician Heroic
}

local function flashBlood()
    a.Flash("Blood Presence")    
    if not s.InCombat() then
        a.Flash("Bone Shield")
        return
    end
    
    -- non-GCD cooldowns
    a.FlashAll("Rune Tap", "Empower Rune Weapon when low")
    c.RotateCooldowns(
        UncontrolledMitigationBuffs,
        "Dancing Rune Weapon",
        "Bone Shield",
        "Vampiric Blood",
        "Fire of the Deep",
        "Icebound Fortitude")
    
    -- rotation
    a.Flash(
        "Death Strike for Health",
        "Death Strike to Save Shield",
        "Blood Tap for Death Strike for Health",
        "Outbreak for Debuffs",
        "Icy Touch for Debuff",
        "Plague Strike for Debuff",
        "Death Strike if Two Available",
        "Rune Strike if Capped",
        "Rune Strike for Runic Empowerment",
        "Heart Strike",
        "Free Blood Boil",
        "Horn of Winter",
        "Outbreak")
end

local obliterateDelay = GetTime()
function a.DelayObliterate()
    obliterateDelay = GetTime() + .9
end
local kmDelay = GetTime()
function a.DelayKM()
    kmDelay = GetTime() + .6
end
local rpBump = 0
local rpBumpTime = 0
function a.BumpRP(amount)
    rpBump = s.Power("player") + amount
    rpBumpTime = GetTime() + .6
end
local function flashNoCap(rp, wouldAdd, spell)
    if s.Castable(a.spells[spell]) then
        if s.MaxPower("player") - rp <= wouldAdd then
            s.Flash(c.GetID("FS"))
        else
            s.Flash(c.GetID(spell))
        end
        return true
    else
        return false
    end
end
local function flashFrost()
    a.Flash("Unholy Presence")
    if not s.InCombat() then
        return
    end
    
    local rp = s.Power("player")
    if rp < rpBump and GetTime() < rpBumpTime then
        rp = rpBump
    end
    
    -- non-GCD cooldowns
    a.FlashAll(
        "Pillar of Frost", 
        "Blood Tap", 
        "Empower Rune Weapon when low")
    
    -- diseases
    local km = GetTime() > kmDelay and c.HasBuff("Killing Machine")
    if km and a.Flash("FS if missing disease") then
        return
    end
    if a.Flash("Outbreak") then
        return
    end
    if flashNoCap(rp, 10, "Rime for FF") then
        return
    end
    if flashNoCap(rp, 20, "HB for FF") then
        return
    end
    if flashNoCap(rp, 10, "PS for BP") then
        return
    end
    
    -- killing machine
    if km then
        if flashNoCap(rp, 30, "OB no Rime") then
            return
        end
        if a.Flash("FS") then
            return
        end
    end
    
    -- obliterate
    local toFill = s.MaxPower("player") - rp
    if a.bothRunesAvailable("Unholy", 1) then
        if toFill <= 30 then
            a.Flash("FS")
            return
        elseif a.Flash("OB") then
            return
        end
    end
    if a.bothRunesAvailable("Unholy", 2) then
        if c.HasBuff("Freezing Fog") then
            if toFill <= 10 then
                a.Flash("FS")
                return
            end
        elseif toFill <= 20 then
            a.Flash("FS")
            return
        end
    end
    
    -- howling blast
    if flashNoCap(rp, 10, "Rime") then
        return
    end
    if flashNoCap(rp, 20, "HB") then
        return
    end
    
    -- frost strike
    a.Flash("FS", "Horn of Winter")
end

s.Spam[AddonName] = function()
    c.Init(AddonName, a)
    c.Run(
        { flashBlood, 1, "blood_off" },
        { flashFrost, 2, "frost_off" })
end
